diff --git a/src/main/java/net/minecraft/core/world/type/WorldTypes.java b/src/main/java/net/minecraft/core/world/type/WorldTypes.java
index 9bc260d22..3a2dacbd9 100644
--- a/src/main/java/net/minecraft/core/world/type/WorldTypes.java
+++ b/src/main/java/net/minecraft/core/world/type/WorldTypes.java
@@ -1,30 +1,195 @@
 package net.minecraft.core.world.type;
 
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.world.config.season.SeasonConfig;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.nether.WorldTypeNether;
+import net.minecraft.core.world.type.nether.WorldTypeNetherSkyblock;
+import net.minecraft.core.world.type.overworld.*;
+import net.minecraft.core.world.type.paradise.WorldTypeParadise;
+import net.minecraft.core.world.weather.Weathers;
 
-public abstract class WorldTypes
-{
-    public static final WorldType OVERWORLD_EXTENDED = register("minecraft:overworld.extended", new WorldTypeOverworldExtended("worldType.overworld.extended"));
-    public static final WorldType OVERWORLD_DEFAULT = register("minecraft:overworld.default", new WorldTypeOverworldDefault("worldType.overworld.default"));
-    public static final WorldType NETHER_DEFAULT = register("minecraft:nether.default", new WorldTypeNetherDefault("worldType.nether.default"));
-    public static final WorldType PARADISE_DEFAULT = register("minecraft:paradise.default", new WorldTypeParadiseDefault("worldType.paradise.default"));
-    public static final WorldType FLAT = register("minecraft:flat", new WorldTypeFlat("worldType.flat"));
-    public static final WorldType OVERWORLD_FLOATING = register("minecraft:overworld.floating", new WorldTypeOverworldFloating("worldType.overworld.floating"));
-    public static final WorldType OVERWORLD_AMPLIFIED = register("minecraft:overworld.amplified", new WorldTypeOverworldAmplified("worldType.overworld.amplified"));
-    public static final WorldType OVERWORLD_RETRO = register("minecraft:overworld.retro", new WorldTypeOverworldRetro("worldType.overworld.retro"));
-    public static final WorldType OVERWORLD_ISLANDS = register("minecraft:overworld.islands", new WorldTypeOverworldIslands("worldType.overworld.islands"));
-    public static final WorldType OVERWORLD_WINTER = register("minecraft:overworld.winter", new WorldTypeOverworldWinter("worldType.overworld.winter"));
-    public static final WorldType OVERWORLD_HELL = register("minecraft:overworld.hell", new WorldTypeOverworldHell("worldType.overworld.hell"));
-    public static final WorldType OVERWORLD_WOODS = register("minecraft:overworld.woods", new WorldTypeOverworldWoods("worldType.overworld.woods"));
-    public static final WorldType OVERWORLD_PARADISE = register("minecraft:overworld.paradise", new WorldTypeOverworldParadise("worldType.overworld.paradise"));
-    public static final WorldType OVERWORLD_INLAND = register("minecraft:overworld.inland", new WorldTypeOverworldInland("worldType.overworld.inland"));
-    public static final WorldType OVERWORLD_CLASSIC = register("minecraft:overworld.classic", new WorldTypeOverworldClassic("worldType.overworld.classic"));
-    public static final WorldType OVERWORLD_INDEV = register("minecraft:overworld.indev", new WorldTypeOverworldIndev("worldType.overworld.indev"));
-    public static final WorldType EMPTY = register("minecraft:empty", new WorldTypeEmpty("worldType.empty"));
-    public static final WorldType DEBUG = register("minecraft:debug", new WorldTypeDebug("worldType.debug"));
+public abstract class WorldTypes {
+    public static final WorldType OVERWORLD_EXTENDED = register(
+            "minecraft:overworld.extended",
+            new WorldTypeOverworld(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.extended")
+            )
+    );
+    public static final WorldType OVERWORLD_DEFAULT = register(
+            "minecraft:overworld.default",
+            new WorldTypeOverworld(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.default")
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType NETHER_DEFAULT = register(
+            "minecraft:nether.default",
+            new WorldTypeNether(
+                    WorldTypeNether.defaultProperties("worldType.nether.default")
+            )
+    );
+    public static final WorldType NETHER_SKYBLOCK = register(
+            "minecraft:nether.skyblock",
+            new WorldTypeNetherSkyblock(
+                    WorldTypeNether.defaultProperties("worldType.nether.skyblock")
+                        .bounds(0, 127, 0)
+            )
+    );
+    public static final WorldType PARADISE_DEFAULT = register(
+            "minecraft:paradise.default",
+            new WorldTypeParadise(
+                    WorldTypeParadise.defaultProperties("worldType.paradise.default")
+            )
+    );
+    public static final WorldType FLAT = register(
+            "minecraft:flat",
+            new WorldTypeFlat(
+                    WorldType.Properties.of("worldType.flat")
+                            .brightnessRamp(WorldTypeOverworld.createLightRamp())
+                            .fillerBlock(Blocks.STONE)
+                            .allowRespawn()
+                            .bounds(0, 31, 0)
+                            .cloudHeight(256f - 20f)
+                            .seasonConfig(SeasonConfig.builder()
+                                    .withSingleSeason(Seasons.OVERWORLD_SUMMER)
+                                    .build()
+                            )
+            )
+    );
+    public static final WorldType OVERWORLD_FLOATING = register(
+            "minecraft:overworld.floating",
+            new WorldTypeOverworldFloating(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.floating")
+                            .bounds(0, 255, 0)
+                            .oceanBlock(null)
+                            .cloudHeight(32f)
+            )
+    );
+    public static final WorldType OVERWORLD_AMPLIFIED = register(
+            "minecraft:overworld.amplified",
+            new WorldTypeOverworld(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.amplified")
+                            .bounds(0, 255, 64)
+                            .cloudHeight(128f - 20f)
+            )
+    );
+    public static final WorldType OVERWORLD_RETRO = register(
+            "minecraft:overworld.retro",
+            new WorldTypeOverworldRetro(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.retro")
+                            .seasonConfig(null)
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType OVERWORLD_ISLANDS = register(
+            "minecraft:overworld.islands",
+            new WorldTypeOverworld(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.islands")
+                            .bounds(0, 255, 160)
+            )
+    );
+    public static final WorldType OVERWORLD_WINTER = register(
+            "minecraft:overworld.winter",
+            new WorldTypeOverworld(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.winter")
+                            .seasonConfig(SeasonConfig.builder()
+                                    .withSingleSeason(Seasons.OVERWORLD_WINTER_ENDLESS)
+                                    .build()
+                            )
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType OVERWORLD_HELL = register(
+            "minecraft:overworld.hell",
+            new WorldTypeOverworldHell(
+                    WorldType.Properties.of("worldType.overworld.hell")
+                            .brightnessRamp(WorldTypeOverworld.createLightRamp())
+                            .seasonConfig(SeasonConfig.builder()
+                                    .withSingleSeason(Seasons.OVERWORLD_HELL)
+                                    .build()
+                            )
+                            .oceanBlock(Blocks.FLUID_LAVA_STILL)
+                            .fillerBlock(Blocks.STONE)
+                            .allowRespawn()
+                            .bounds(0, 127, 64)
+                            .defaultWeather(Weathers.OVERWORLD_CLEAR_HELL)
+            )
+    );
+    public static final WorldType OVERWORLD_WOODS = register(
+            "minecraft:overworld.woods",
+            new WorldTypeOverworldWoods(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.woods")
+                            .defaultWeather(Weathers.OVERWORLD_CLEAR_WOODS)
+            )
+    );
+    public static final WorldType OVERWORLD_PARADISE = register(
+            "minecraft:overworld.paradise",
+            new WorldTypeOverworldParadise(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.paradise")
+                            .seasonConfig(SeasonConfig.builder()
+                                    .withSingleSeason(Seasons.OVERWORLD_SPRING)
+                                    .build()
+                            )
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType OVERWORLD_INLAND = register(
+            "minecraft:overworld.inland",
+            new WorldTypeOverworldInland(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.inland")
+                            .bounds(0, 255, 0)
+                            .oceanBlock(null)
+            )
+    );
+    public static final WorldType OVERWORLD_CLASSIC = register(
+            "minecraft:overworld.classic",
+            new WorldTypeOverworldClassic(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.classic")
+                            .seasonConfig(null)
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType OVERWORLD_INDEV = register(
+            "minecraft:overworld.indev",
+            new WorldTypeOverworldIndev(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.indev")
+                            .seasonConfig(null)
+                            .bounds(0, 127, 64)
+            )
+    );
+    public static final WorldType OVERWORLD_SKYBLOCK = register(
+            "minecraft:overworld.skyblock",
+            new WorldTypeOverworldSkyblock(
+                    WorldTypeOverworld.defaultProperties("worldType.overworld.skyblock")
+                        .bounds(0, 127, 0)
+            )
+    );
+    public static final WorldType EMPTY = register(
+            "minecraft:empty",
+            new WorldTypeEmpty(
+                    WorldType.Properties.of("worldType.empty")
+                            .brightnessRamp(WorldTypeEmpty.createLightRamp())
+                            .bounds(0, 255, 0)
+                            .allowRespawn()
+                            .cloudHeight(128f - 20f)
+                            .noGround()
+            )
+    );
+    public static final WorldType DEBUG = register(
+            "minecraft:debug",
+            new WorldTypeDebug(
+                    WorldType.Properties.of("worldType.debug")
+                            .brightnessRamp(WorldTypeDebug.createLightRamp())
+                            .bounds(0, 255, 0)
+                            .allowRespawn()
+                            .cloudHeight(128f - 20f)
+                            .noGround()
+            )
+    );
 
-    public static WorldType register(String key, WorldType worldType)
-    {
+    public static WorldType register(String key, WorldType worldType) {
         Registries.WORLD_TYPES.register(key, worldType);
 
         return worldType;
diff --git a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
new file mode 100644
index 000000000..1fb276125
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNether.java
@@ -0,0 +1,95 @@
+package net.minecraft.core.world.type.nether;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.nether.ChunkGeneratorNether;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeNether
+        extends WorldType {
+    public WorldTypeNether(Properties properties) {
+        super(properties);
+    }
+
+    public static Properties defaultProperties(String translationKey) {
+        return Properties.of(translationKey)
+                .brightnessRamp(getLightRamp())
+                .oceanBlock(Blocks.FLUID_LAVA_STILL)
+                .fillerBlock(Blocks.NETHERRACK)
+                .noClouds()
+                .noSky()
+                .withCeiling()
+                .bounds(128, 255, 32);
+    }
+
+    private static float[] getLightRamp() {
+        float[] brightnessRamp = new float[32];
+        float f = 0.1F;
+        for (int i = 0; i <= 15; i++) {
+            float f1 = 1.0F - (float) i / 15F;
+            brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
+        }
+        return brightnessRamp;
+    }
+
+    @Override
+    public void onWorldCreation(World world) {
+        super.onWorldCreation(world);
+
+        world.setWorldTime(72000);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.NETHER_NETHER, 1.0, 0.0, 1.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorNether(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return true;
+    }
+
+    @Override
+    public float getCelestialAngle(World world, long tick, float partialTick) {
+        return 0.5f;
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        return new float[4];
+    }
+
+    @Override
+    public int getSkyDarken(World world, long tick, float partialTick) {
+        return 0;
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            float r = ((color >> 16) & 0xFF) / 255.0f;
+            float g = ((color >> 8) & 0xFF) / 255.0f;
+            float b = (color & 0xFF) / 255.0f;
+            return Vec3.getTempVec3(r, g, b);
+        }
+        return Vec3.getTempVec3(0.0, 0.0, 0.0);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNetherSkyblock.java b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNetherSkyblock.java
new file mode 100644
index 000000000..ea71bcce3
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/nether/WorldTypeNetherSkyblock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.world.type.nether;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.skyblock.ChunkGeneratorSkyblockNether;
+
+public class WorldTypeNetherSkyblock
+    extends WorldTypeNether {
+    public WorldTypeNetherSkyblock(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorSkyblockNether(world);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
new file mode 100644
index 000000000..d9e5b0b8c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeFlat.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.flat.ChunkGeneratorFlat;
+
+public class WorldTypeFlat
+        extends WorldTypeOverworld {
+    public WorldTypeFlat(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_PLAINS, 0.5, 0.0, 0.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorFlat(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return world.getBlockId(x, y, z) == Blocks.GRASS.id;
+    }
+
+    @Override
+    public void getRespawnLocation(World world) {
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
new file mode 100644
index 000000000..a252deae4
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -0,0 +1,142 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
+import net.minecraft.core.world.config.season.SeasonConfig;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkGeneratorOverworld;
+import net.minecraft.core.world.season.Seasons;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.weather.Weather;
+
+public class WorldTypeOverworld
+        extends WorldType {
+    public WorldTypeOverworld(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public void onWorldCreation(World world) {
+        super.onWorldCreation(world);
+
+        world.setWorldTime(72000 + 3000);
+    }
+
+    public static Properties defaultProperties(String translationKey) {
+        return Properties.of(translationKey)
+                .brightnessRamp(createLightRamp())
+                .seasonConfig(SeasonConfig.builder()
+                        .withSeasonInCycle(Seasons.OVERWORLD_SPRING, 14)
+                        .withSeasonInCycle(Seasons.OVERWORLD_SUMMER, 14)
+                        .withSeasonInCycle(Seasons.OVERWORLD_FALL, 14)
+                        .withSeasonInCycle(Seasons.OVERWORLD_WINTER, 14)
+                        .build()
+                )
+                .oceanBlock(Blocks.FLUID_WATER_STILL)
+                .fillerBlock(Blocks.STONE)
+                .allowRespawn()
+                .withAurora();
+    }
+
+    public static float[] createLightRamp() {
+        float[] brightnessRamp = new float[32];
+        float f = 0.05F;
+        for (int i = 0; i <= 31; i++) {
+            float f1 = 1.0F - (float) i / 15F;
+            if (i > 15) f1 = 0.0f;
+            brightnessRamp[i] = ((1.0F - f1) / (f1 * 3F + 1.0F)) * (1.0F - f) + f;
+        }
+        return brightnessRamp;
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderOverworld(world.getRandomSeed(), this);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorOverworld(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        return world.getBlockId(x, y, z) == Blocks.SAND.id;
+    }
+
+    @Override
+    public float getCelestialAngle(World world, long tick, float partialTick) {
+        return getTimeOfDay(world, tick, partialTick);
+    }
+
+    @Override
+    public float[] getSunriseColor(float timeOfDay, float partialTick) {
+        float[] sunriseCol = new float[4];
+        float sunriseMinimum = 0.4F;
+
+        // Gives a value that goes from 1 to -1 to 1 over the course of a day
+        float sunrisePresence = MathHelper.cos(timeOfDay * MathHelper.PI * 2.0F);
+        float middle = 0F;
+        if (sunrisePresence >= middle - sunriseMinimum && sunrisePresence <= middle + sunriseMinimum) {
+            float c = ((sunrisePresence - middle) / sunriseMinimum) * 0.5F + 0.5F;
+            float a = 1.0F - (1.0F - MathHelper.sin(c * MathHelper.PI)) * 0.99F;
+            a *= a;
+            sunriseCol[0] = c * 0.3F + 0.7F;
+            sunriseCol[1] = c * c * 0.7F + 0.2F;
+            sunriseCol[2] = c * c * 0.0F + 0.2F;
+            sunriseCol[3] = a;
+            return sunriseCol;
+        } else {
+            return null;
+        }
+    }
+
+    @Override
+    public int getSkyDarken(World world, long tick, float partialTick) {
+        float f1 = getCelestialAngle(world, tick, partialTick);
+        float f2 = 1.0F - (MathHelper.cos(f1 * MathHelper.PI * 2.0F) * 2.0F + 0.5F);
+        if (f2 < 0.0F) {
+            f2 = 0.0F;
+        }
+        if (f2 > 1.0F) {
+            f2 = 1.0F;
+        }
+        float weatherOffset = 0;
+        Weather currentWeather = world.getCurrentWeather();
+        if (currentWeather != null)
+            weatherOffset = currentWeather.subtractLightLevel * world.weatherManager.getWeatherIntensity() * world.weatherManager.getWeatherPower();
+        return (int) (f2 * (11F - weatherOffset) + weatherOffset);
+    }
+
+    @Override
+    public Vec3 getFogColor(World world, double x, double y, double z, float celestialAngle, float partialTick) {
+        float dayProgress = MathHelper.cos(celestialAngle * MathHelper.PI * 2.0F) * 2.0F + 0.5F;
+        dayProgress = MathHelper.clamp(dayProgress, 0.0f, 1.0f);
+        float r, g, b;
+
+        if (Colorizers.fog.isEnabled()) {
+            int x1 = MathHelper.floor(x);
+            int y1 = MathHelper.floor(y);
+            int z1 = MathHelper.floor(z);
+
+            int color = Colorizers.fog.getColor(world, x1, y1, z1);
+
+            r = ((color >> 16) & 0xFF) / 255.0f;
+            g = ((color >> 8) & 0xFF) / 255.0f;
+            b = (color & 0xFF) / 255.0f;
+        } else {
+            r = 0.7529412f;
+            g = 0.8470588f;
+            b = 1.0f;
+        }
+        r *= dayProgress * 0.94f + 0.06f;
+        g *= dayProgress * 0.94f + 0.06f;
+        b *= dayProgress * 0.91f + 0.09f;
+        return Vec3.getTempVec3(r, g, b);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
new file mode 100644
index 000000000..af5134ee1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldClassic.java
@@ -0,0 +1,26 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.classic.ChunkGeneratorClassic;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeOverworldClassic
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldClassic(WorldType.Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_RETRO, 1.0, 1.0, 1.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorClassic(world);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
new file mode 100644
index 000000000..c269a8122
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldFloating.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.floating.ChunkGeneratorOverworldFloating;
+import net.minecraft.core.world.type.WorldType;
+
+public class WorldTypeOverworldFloating
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldFloating(WorldType.Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderOverworld(world.getRandomSeed(), this)
+                .withTemperatureScales(0.00625, 0.00625, 0.25, 0.01)
+                .withHumidityScales(0.0125, 0.0125, 0.3, 0.01)
+                .withFuzzinessScales(8, 8, 0.025);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorOverworldFloating(world);
+    }
+
+    @Override
+    public boolean isValidSpawn(World world, int x, int y, int z) {
+        Block block = world.getBlock(x, y, z);
+        return world.getHeightValue(x, z) > 0 && block != null && block.isSolidRender();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
new file mode 100644
index 000000000..771e3419c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworldHell.java
@@ -0,0 +1,37 @@
+package net.minecraft.core.world.type.overworld;
+
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.biome.provider.BiomeProvider;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
+import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.generate.chunk.perlin.overworld.hell.ChunkGeneratorOverworldHell;
+
+public class WorldTypeOverworldHell
+        extends WorldTypeOverworld {
+    public WorldTypeOverworldHell(Properties properties) {
+        super(properties);
+    }
+
+    @Override
+    public void onWorldCreation(World world) {
+        super.onWorldCreation(world);
+
+        world.setWorldTime(576000);
+    }
+
+    @Override
+    public BiomeProvider createBiomeProvider(World world) {
+        return new BiomeProviderSingleBiome(Biomes.OVERWORLD_HELL, 1.0, 1.0, 0.0);
+    }
+
+    @Override
+    public ChunkGenerator createChunkGenerator(World world) {
+        return new ChunkGeneratorOverworldHell(world);
+    }
+
+    @Override
+    public float getCelestialAngle(World world, long tick, float partialTick) {
+        return 0.5f;
+    }
+}
